--[[ gearDisplay 

Author: 		HoFFi
Remarks:		


Description: 	script for gearDisplay

Version: 		1.0.0.0

Changelog: 		2023-05-02 	- initial release


--------------------------------------------------------------------------------------------------


]]


gearDisplay = {};

gearDisplay.modDir = g_currentModDirectory;
gearDisplay.currentModName = g_currentModName;

function gearDisplay.prerequisitesPresent(specializations)
    return true; 
end;

function gearDisplay.registerEventListeners(vehicleType)
	for _, spec in pairs({"onLoad", "onUpdate", "onDraw"}) do
		SpecializationUtil.registerEventListener(vehicleType, spec, gearDisplay)
	end
end

function gearDisplay:onLoad(savegame)
	self.gearDisplay = {}
	self.currentGear = {}
	self.gear1node = I3DUtil.indexToObject(self.components, "gear1node", self.i3dMappings);
	self.gear2node = I3DUtil.indexToObject(self.components, "gear2node", self.i3dMappings);
	self.gear3node = I3DUtil.indexToObject(self.components, "gear3node", self.i3dMappings);
	self.gear4node = I3DUtil.indexToObject(self.components, "gear4node", self.i3dMappings);
	self.gear5node = I3DUtil.indexToObject(self.components, "gear5node", self.i3dMappings);
	self.gear6node = I3DUtil.indexToObject(self.components, "gear6node", self.i3dMappings);
	self.gear7node = I3DUtil.indexToObject(self.components, "gear7node", self.i3dMappings);
	self.gear8node = I3DUtil.indexToObject(self.components, "gear8node", self.i3dMappings);
	self.gear9node = I3DUtil.indexToObject(self.components, "gear9node", self.i3dMappings);
	self.gearNnode = I3DUtil.indexToObject(self.components, "gearNnode", self.i3dMappings);
	self.gearFnode = I3DUtil.indexToObject(self.components, "gearFnode", self.i3dMappings);
	self.gearBnode = I3DUtil.indexToObject(self.components, "gearBnode", self.i3dMappings);
	self.gearDecal = I3DUtil.indexToObject(self.components, "decalAnzeigeIllum", self.i3dMappings);
end;

function gearDisplay:onUpdate(dt, light)
	if self.isClient then
		if self:getIsMotorStarted() then
			self.currentGear = self:getGearInfoToDisplay(gear)
			if self.currentGear == "1" or self.currentGear == "-1" then
				setVisibility(self.gear1node, true)
			else
				setVisibility(self.gear1node, false)
			end
			
			if self.currentGear == "2" or self.currentGear == "-2" then
				setVisibility(self.gear2node, true)
			else
				setVisibility(self.gear2node, false)
			end
			
			if self.currentGear == "3" or self.currentGear == "-3" then
				setVisibility(self.gear3node, true)
			else
				setVisibility(self.gear3node, false)
			end
			
			if self.currentGear == "4" or self.currentGear == "-4" then
				setVisibility(self.gear4node, true)
			else
				setVisibility(self.gear4node, false)
			end
			
			if self.currentGear == "5" or self.currentGear == "-5" then
				setVisibility(self.gear5node, true)
			else
				setVisibility(self.gear5node, false)
			end
			
			if self.currentGear == "6" or self.currentGear == "-6" then
				setVisibility(self.gear6node, true)
			else
				setVisibility(self.gear6node, false)
			end
			
			if self.currentGear == "7" or self.currentGear == "-7" then
				setVisibility(self.gear7node, true)
			else
				setVisibility(self.gear7node, false)
			end
			
			if self.currentGear == "8" or self.currentGear == "-8" then
				setVisibility(self.gear8node, true)
			else
				setVisibility(self.gear8node, false)
			end
			
			if self.currentGear == "9" or self.currentGear == "-9" then
				setVisibility(self.gear9node, true)
			else
				setVisibility(self.gear9node, false)
			end
			
			if self.currentGear == "N" then
				setVisibility(self.gearNnode, true)
			else
				setVisibility(self.gearNnode, false)
			end
			
			if self.currentGear == "1" or self.currentGear == "2" or self.currentGear == "3" or self.currentGear == "4" or self.currentGear == "5" or self.currentGear == "6" or self.currentGear == "7" or self.currentGear == "8" or self.currentGear == "9" then
				setVisibility(self.gearFnode, true)
				setVisibility(self.gearBnode, false)
			elseif self.currentGear == "-1" or self.currentGear == "-2" or self.currentGear == "-3" or self.currentGear == "-4" or self.currentGear == "-5" or self.currentGear == "-6" or self.currentGear == "-7" or self.currentGear == "-8" or self.currentGear == "-9" then
				setVisibility(self.gearFnode, false)
				setVisibility(self.gearBnode, true)
			end
			
			if self:getLightsTypesMask() == 0 then
				setShaderParameter(self.gear1node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear1node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear2node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear2node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear3node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear3node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear4node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear4node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear5node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear5node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear6node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear6node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear7node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear7node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear8node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear8node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear9node, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gear9node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gearFnode, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gearFnode, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gearNnode, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gearNnode, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gearBnode, "lightControl", 0.01, 0, 0, 0, false)
				setShaderParameter(self.gearBnode, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gearDecal, "lightControl", 0, 0, 0, 0, false)
			elseif self:getLightsTypesMask() == 1 then
				setShaderParameter(self.gear1node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear1node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear2node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear2node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear3node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear3node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear4node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear4node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear5node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear5node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear6node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear6node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear7node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear7node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear8node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear8node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gear9node, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gear9node, "colorMat0", 0.6, 0, 0, 1, false)
				setShaderParameter(self.gearFnode, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gearFnode, "colorMat0", 0.8, 0, 0, 1, false)
				setShaderParameter(self.gearNnode, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gearNnode, "colorMat0", 0.8, 0, 0, 1, false)
				setShaderParameter(self.gearBnode, "lightControl", 1, 0, 0, 0, false)
				setShaderParameter(self.gearBnode, "colorMat0", 0.8, 0, 0, 1, false)
				setShaderParameter(self.gearDecal, "lightControl", 0.5, 0, 0, 0, false)
			end
		end
		
		if self:getIsMotorStarted() == false then
			setVisibility(self.gear1node, false)
			setVisibility(self.gear2node, false)
			setVisibility(self.gear3node, false)
			setVisibility(self.gear4node, false)
			setVisibility(self.gear5node, false)
			setVisibility(self.gear6node, false)
			setVisibility(self.gear7node, false)
			setVisibility(self.gear8node, false)
			setVisibility(self.gear9node, false)
			setVisibility(self.gearFnode, false)
			setVisibility(self.gearNnode, false)
			setVisibility(self.gearBnode, false)
		end
	end;
end;

function gearDisplay:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if self.isClient then
		text1 = self:getGearInfoToDisplay(gear)
		text2 = self:getLightsTypesMask()
		g_currentMission:addExtraPrintText("Current gear: " .. text1 .. " | " .. text2)
	end
end